/*
 * (C) Copyright IBM Corp. 2001
 */
//$Id: OPT_CompoundEnumerator.java,v 1.2 2001/10/08 03:19:02 pfs-oss Exp $

import java.util.*;

/** 
 * @author Mauricio J. Serrano
 * @author John Whaley
 */
class OPT_CompoundEnumerator implements Enumeration {
    private final Enumeration first;    
    private final Enumeration second;

    OPT_CompoundEnumerator(Enumeration first, Enumeration second) {
	this.first = first;
	this.second = second;
    }

    public boolean hasMoreElements() {
	return first.hasMoreElements()||second.hasMoreElements();
    }

    public Object nextElement() {
	if (first.hasMoreElements())
	    return first.nextElement();
	else
	    return second.nextElement();
    }
}
