/*
 * (C) Copyright IBM Corp. 2001
 */
//$Id: VM_ObjectAddressRemapper.java,v 1.2 2001/10/08 03:20:30 pfs-oss Exp $

/**
 * Facility for remapping object addresses across virtual machine address 
 * spaces.  Used by boot image writer to map local (jdk) objects into remote 
 * (boot image) addresses.  Used by debugger to map local (jdk) objects into 
 * remote (debugee vm) addresses.
 *
 * See also VM_Magic.setObjectAddressRemapper()
 *
 * @author Bowen Alpern
 * @author Derek Lieber
 */
interface VM_ObjectAddressRemapper
   {
   // Map an object to an address.
   // Taken:    an object in "local" virtual machine
   // Returned: its address in a foreign virtual machine
   //
   public int objectAsAddress(Object object);

   // Map an address to an object.
   // Taken:    value obtained from "objectAsAddress"
   // Returned: corresponding object
   //
   public Object addressAsObject(int address);
   }
